c		program addgrd
c  node by node algebraic operations between two grids

	parameter  (maxcol=4000, mnrecl=30 )
	dimension  r(maxcol), r2(maxcol)

	character*56 ifile, i2file, ofile, constant
	character*56 id, id2, id3, b56
	character    opr*1, pgm*8, pgm2*8
	data	     dval/0.170412e+39/, constant/'constant'/,
     1	     inp/12/, inp2/13/, jput/14/

	opr    = ' '
	ifile  = ' '
	i2file = ' '
	ofile  = ' '
	id     = ' '
	id2    = ' '
	id3    = ' '
	b56    = ' '

1	print*, ' first input file :'
      read(5,37) ifile
37	format( a )

	open ( unit=inp, file=ifile, status='old', form='unformatted',
     1	mode='read', iostat=ios )
2	if ( ios .ne. 0 ) then
	  print*, ' file not found'
	  go to 1
	endif

	call rdhdr( inp, id, pgm, nc,nr,nz, xo,dx,yo,dy,
     1	iprj, cmerid, baslat )
	print*, 'title=', id
	print*,     ' nc X nr        =', nc, nr
	print*,     ' xo, yo, dx, dy =', xo, yo, dx, dy
	if ( iprj .gt. 0 )
     1	print*, ' iprj, cm, bl   =', iprj, cmerid, baslat
      if ( nc .gt. maxcol ) then
	  print*, ' maximum number of columns=', maxcol
	  stop
      endif

10	print*, ' operator  h(elp), + - * / m %   :'
	read(5,37) opr
      if ( opr .eq. 'h' ) then
	print*, ' arithmetic operators: file1 (opr) file2 = ofile'
	  print*, ' masking:  blank areas in 2 overwrite 1'
	  print*, ' % difference =  100 * ( f1 - f2 ) / f1'
	  go to 10
	endif
      if ( .not. ( opr.eq.'+' .or. opr.eq.'-' .or. opr.eq.'*' .or.
     1	opr.eq.'/' .or. opr.eq.'m' .or. opr.eq.'%' ) )
     1	then
	  print*, ' error, please reenter operator'
	  go to 10
      endif

	print*, ' second input file [constant] :'
	read(5,37)	i2file
      if ( i2file(1:1) .eq. ' ' ) then
	  print*, ' the 2nd grid will be replaced by a constant value'
	  i2file = 'constant'
      endif

	icon = 0
	if ( i2file .eq. constant ) then
	  icon = -1
	  print*, ' enter constant:'
	  read*, zc
	  if ( opr .eq. '/' ) then
	    opr = '*'
	    zc  = 1.0 / zc
	  endif
      do 50 i = 1, nc
	    r2(i) = zc
50    continue

	  else

c  open 2nd file and check
	  open ( unit=inp2, file=i2file, status='old',
     1	 form='unformatted', mode='read', iostat=ios )
	  if ( ios .ne. 0 ) go to 2
	  read (inp2) id2, pgm2, nc2,nr2,nz, xo2,dx2,yo2,dy2

c  different sizes are fatal
	if ( nc .ne. nc2 ) stop ' ncolumns differ'
	if ( nr .ne. nr2 ) stop ' nrows differ'

c  warn of coordinate problems
	if ( abs ( ( dx - dx2 ) / dx ) .gt. .001 ) print*, ' dx differ'
	if ( abs ( ( dy - dy2 ) / dy ) .gt. .001 ) print*, ' dy differ'
	tx1 = xo2 - dx * .1
	tx2 = xo2 + dx * .1
	tmx = amax1( tx1, tx2 )
	tmn = amin1( tx1, tx2 )
	if ( xo .lt. tmn  .or.  xo .gt. tmx ) then
	  print*, ' xo1, xo2', xo,xo2
	  print*, ' x origin different'
	endif

	ty1 = yo2 - dy * .1
	ty2 = yo2 + dy * .1
	tmx = amax1( ty1, ty2 )
	tmn = amin1( ty1, ty2 )
	if ( yo .lt. tmn  .or.  yo .gt. tmx ) then
	  print*, ' yo1, yo2', yo,yo2
	  print*, ' y origin different'
	endif
c  end of check

	endif

20	print*, ' output file :'
	read(5,37) ofile
	print*, ' output title [ same as file 1 ]'
	read(5,37) id3
	if ( id3 .ne. b56 ) id = id3

	length = nc + 1
	if ( length .lt. mnrecl ) length = mnrecl
	open ( unit=jput, file=ofile, status='new', form='unformatted',
     1	recl=length, access='sequential' )
	write (jput) id, pgm, nc,nr,nz, xo,dx,yo,dy,
     1	     iprj, cmerid, baslat

	ig = 0
	if ( opr .eq. '+' ) ig = 1
	if ( opr .eq. '-' ) ig = 2
	if ( opr .eq. '*' ) ig = 3
	if ( opr .eq. '/' ) ig = 4
	if ( opr .eq. 'm' ) ig = 5
	if ( opr .eq. '%' ) ig = 6
c
	do 100 j = 1, nr

	  call rowio( nc, r, -1, inp, inp, iend )
	  if ( iend .ne. 0 ) print*,
     1	'warning: premature eof on input grid'
	  if ( icon .eq. 0 )
     1 call rowio( nc2, r2, -1, inp2, inp2, iend2 )
	  if ( iend2 .ne. 0 ) print*,
     1		     'warning: premature eof on input2 grid'

	go to( 41, 42, 43, 44, 45, 46 ) ig

41      do 51 i = 1, nc
	  if ( r(i) .ge. 1.e30  .or.  r2(i) .ge. 1.e30 ) then
	    r(i) = dval
	    else
	    r(i) = r(i) + r2(i)
	  endif
51      continue
	go to 90

42      do 52 i = 1, nc
	  if ( r(i) .ge. 1.e30  .or.  r2(i) .ge. 1.e30 ) then
	    r(i) = dval
	    else
	    r(i) = r(i) - r2(i)
	  endif
52      continue
	go to 90

43      do 53 i = 1, nc
	  if ( r(i) .ge. 1.e30  .or.  r2(i) .ge. 1.e30 ) then
	    r(i) = dval
	    else
	    r(i) = r(i) * r2(i)
	  endif
53      continue
	go to 90

44      do 54 i = 1, nc
       if ( r(i) .ge. 1.e30.or.  r2(i) .ge. 1.e30 .or.
     1 r2(i) .eq. 0 ) then
	    r(i) = dval
       else
	    r(i) = r(i) / r2(i)
       endif
54      continue
	go to 90

c  masking
45      do 55 i = 1, nc
	  if ( r2(i) .ge. 1.e30 ) r(i) = dval
55      continue
	go to 90

c  % difference
46      do 56 i = 1, nc
      if ( r(i) .ge. 1.e30	.or.	r2(i) .ge. 1.e30 .or.
     1 r(i) .eq. 0 ) then
	    r(i) = dval
      else
	    r(i) = 100 * ( r(i) - r2(i) ) / r(i)
      endif
56      continue

90	call rowio( nc, r, 0, jput, jput, iend )
100	continue
c
	close( inp )
	close( jput )
	if ( icon .eq. 0 ) close( inp2 )
	stop
	end
c***********************************************************************
	subroutine rowio( n, z, iop, idev, jdev, iend )
	dimension z(n)
	iend = 0
	if ( iop ) 1, 2, 1
1	read( idev, end=10 ) y,z
	if ( iop ) 9, 9, 2
2	write( jdev ) y, z
9	return
10	iend = 1
	return
	end
c***********************************************************************
	subroutine rdhdr( iunit, id, pgm, nc,nr,nz, xo,dx,yo,dy,
     1			 iproj, cmerid, baslat )
	character id*56, pgm*8
	read( iunit, err=9 )  id, pgm, nc,nr,nz, xo,dx,yo,dy,
     1		      iproj, cmerid, baslat
	return
9	rewind iunit
	read( iunit, err=99 ) id, pgm, nc,nr,nz, xo,dx,yo,dy
	iproj  = 0
	cmerid = 999.
	baslat = 999.
	return
99	print*, ' cannot read grid header'
	stop
	end
