c  prep.for
c
c  To extend a grid, tilt, and cosine taper to reduce FFT wraparound.
c  The new nrow, ncol should be chosen from the list of rich-in-
c  -factors-of-2 numbers that FFTFIL likes.  The program checks that
c  nrow and ncol will not be increased by FFTFIL.
c
c  Lin Cordell Jan 1990.
c  Revised June 1991.
c
	character*50 ifile,ofile
      dimension g(2048),g1(2048),g2(2048),id(14),pgm(2)
      data lnri/16/
	pi=3.141597
      print*, 'Enter input grid name (NO DVALS !):'
	print 101
101	format(' *',$)
	read(5,1)ifile
1	format(a50)
	print*, 'Enter (new) ncol and nrow:'
	print 101
      read*, ncol,nrow
c  Check to make sure FFTFIL will use these unchanged.
c  Added 19 June 91.
      kr=11
      iw=6
      ir=5
      nadd=0
c  note that x & y have been switched from normal (usgs) grid specficati
c  ...convention used is x-north y-east and z-down
      n1=nrow
      n2=ncol
      nx=n1
      ny=n2
      l=lnri+1
      lnri21=lnri/2+1
c  set no. of rows for fft: need m=l*2**k, m.gt. or .eq. nx+2*nadd.
c  m=no. of rows, l=no. from 9-16, k=interger.
      n1=n1+2*nadd
  190 l=l-1
      if(l.lt.lnri21) go to 260
      mr=n1/l+0.0000001
      k=1
      idiv=2
  200 iquot=mr/idiv+0.0000001
      if(iquot.lt.idiv) go to 210
      k=k+1
      mr=iquot
      go to 200
  210 k=k+1
      m=l*2**k
  220 mtest=l*2**(k-1)
      if(mtest.lt.n1) go to 230
      k=k-1
      m=mtest
      if(k.eq.0) go to 230
      go to 220
  230 lnxa=m-n1
      if(l.ne.lnri) go to 250
      nxa16=lnxa
  240 nri=l
      nxa=lnxa
      go to 190
  250 if(lnxa.ge.nxa) go to 190
      go to 240
  260 n1=n1+nxa
c  check to see if row block size of 16 will be more efficient
      n116=n1-nxa+nxa16
      ntest=0.9*n116
      if(ntest.gt.n1.or.n116.gt.2048) go to 270
      n1=n1-nxa+nxa16
      nxa=nxa16
      nri=16
  270 n2=n2+2*nadd
      if(n1.gt.2048.or.n2.gt.2048) then
        print*,'Too big.'
        stop
      endif
      nxa=nxa+2*nadd
      id2=n1
      if(n2.gt.n1)id2=n2
      id2=2*id2
      itest=n1-nx
      if(itest.ne.0) then
        print*,'Select another nrow; FFTFIL would change this one.'
        stop
      endif
      open(10,file=ifile,status='old',form='unformatted')
c  Tilt grid.
	read(10)id,pgm,nc,nr,nz,xo,dx,yo,dy
      if(nc.gt.ncol.or.nr.gt.nrow)then
        print*,'Too small.'
        stop
      endif
      write(iw,275)nri
  275 format(' blocking rows =',i3)
      call rowio(g,y,nz,nc,10,1)
	a=g(1)
	b=g(nc)
	do 10 j2=2,nr
10	call rowio(g,y,nz,nc,10,1)
	c=g(1)
	d=g(nc)
	close(10)
	alpha=(c-b)/float(2*(nc-1))
	beta=(b-c)/float(2*(nr-1))
	print*, ' alpha = ',alpha,', beta = ',beta
	open(10,file=ifile,status='old',form='unformatted')
	read(10)id,pgm,nc,nr,nz,xo,dx,yo,dy
      open(14,file='prep.rec',status='new',form='formatted')
	write(14,300)ofile,alpha,beta,nc,nr
300	format(a50/2e16.8,2i5)
      close(14)
c  Output extended file.
      print*, 'Enter output grid name:'
	print 101
	read(5,1)ofile
      open(11,file=ofile,status='new',form='unformatted')
	pgm(1)='prep'
	pgm(2)='    '
	write(11)id,pgm,ncol,nrow,nz,xo,dx,yo,dy
c  First row (saved).
	j2=1
	call rowio(g,yr,nz,nc,10,1)
      do 211 j1=1,nc
	x=float(j1-1)
	g(j1)=g(j1)+alpha*x
211   g1(j1)=g(j1)
c  Cosine taper right side.
	s=0.5*(g(nc)+g(1))
	r=0.5*(g(nc)-g(1))
	lim=ncol-nc
	rlamb=float(lim+1)
	arg=pi/rlamb
	do 201 k=1,lim
	rk=float(k)
	ge=s+r*cos(arg*rk)
	g(nc+k)=ge
201	g1(nc+k)=ge
	call rowio(g,yr,nz,ncol,11,2)
c  Rows down to nr.
	do 204 j2=2,nr
	y=float(j2-1)
	call rowio(g,yr,nz,nc,10,1)
	do 202 j1=1,nc
	x=float(j1-1)
202	g(j1)=g(j1)+alpha*x+beta*y
c  Cosine taper right side.
	s=0.5*(g(nc)+g(1))
	r=0.5*(g(nc)-g(1))
	do 203 k=1,lim
	rk=float(k)
203	g(nc+k)=s+r*cos(arg*rk)
	call rowio(g,yr,nz,ncol,11,2)
204	continue
c  Last row.
	do 205 j1=1,ncol
205	g2(j1)=g(j1)
c  Rows nr to nrow.
c  Cosine taper.
	lim=nrow-nr
	rlamb=float(lim+1)
	arg=pi/rlamb
	do 207 k=1,lim
	yr=float(nr+k-1)*dx+yo
	rk=float(k)
	do 206 j1=1,ncol
	s=0.5*(g2(j1)+g1(j1))
	r=0.5*(g2(j1)-g1(j1))
206	g(j1)=s+r*cos(arg*rk)
	call rowio(g,yr,nz,ncol,11,2)
207	continue
	go to 999
900	print*, 'Cant handle it.'
	close(10)
999	close(11)
	stop
	end
      subroutine rowio(a,y,nz,ncol,ld,key)
      dimension a(nz,ncol)
      go to (1,2),key
1     read(ld) y,a
      go to 90
2     write(ld)y,a
90    return
      end
