@echo off
echo .
if exist %1.%2 goto begin
echo This procedure terraces an input grid file that is
echo in USGS standard grid format.
echo .
echo USAGE: terrace P1 P2 P3
echo .
echo P1 is the input file name prefix
echo P2 is the input filename suffix
echo P3 is the number of iterations to be used
echo .
echo EXAMPLE: 
echo To terrace the grid file MYDATA.GRD with 20 iterations,
echo type: terrace MYDATA GRD 20
echo .
goto done
:begin
echo . > temp
for %%f in (%1.ter %1.fil) do if exist %%f echo Warning: %%f will be overwritten.
for %%f in (%1.ter %1.fil) do if exist %%f if exist temp del temp
if not exist temp echo .
if not exist temp echo Hit Ctrl-Break to abort, otherwise . . .
if not exist temp pause
echo %1.%2 > temp
echo %1.tmp >> temp
echo gradient of %1.%2 >> temp
echo .
echo ** Running the gradient program **
gradient < temp >> nul
echo %1.tmp > temp
echo %1.ter >> temp
echo 0 >> temp
echo ** Running the stdbndy program **
stdbndy < temp >> nul
echo %1.%2 > temp
echo %1.ter >> temp
echo %1.tmp >> temp
echo ** Running the combgr program **
combgr < temp >> nul
echo %1.tmp > temp
echo %1.ter >> temp
echo %3 >> temp
echo terrace of %1.%2 with %3 iterations >> temp
echo ** Running the terrace4 program **
echo .
terrace4 < temp
echo %1.ter > temp
echo %1.tmp >> temp
echo 1 >> temp
echo transpose of %1.ter >> temp
echo ** Running the transpos program **
transpos < temp >> nul
echo %1.tmp > temp
echo %1.ter >> temp
echo ** Running the fixter program **
fixter < temp >> nul
echo %1.ter > temp
echo %1.tmp >> temp
echo 1 >> temp
echo transpose of %1.ter >> temp
echo ** Running the transpos program **
transpos < temp >> nul
echo %1.tmp > temp
echo %1.ter >> temp
echo ** Running the fixter program **
fixter < temp >> nul
echo %1.ter > temp
echo %1.tmp >> temp
echo ** Running the mediplug program **
mediplug < temp >> nul
echo %1.tmp > temp
echo %1.fil >> temp
echo 1 >> temp
echo ** Running the medifilt program **
medifilt < temp >> nul
echo ** Deleting temporary files
del %1.tmp
del temp
echo .
echo ** Done:  %1.ter, %1.fil created **
:done

